var myLang = {
  cn: {
    //加载状态提示。
    LOADING: "加载中...",
    //等待滑动状态提示。
    SLIDE: "请向右滑动验证",
    //验证通过状态提示。
    SUCCESS: "验证通过",
    //验证失败触发拦截状态提示。
    ERROR: "非常抱歉，网络出错了...",
    //验证失败触发拦截状态提示。
    FAIL: "验证失败，请重试",
  },
};

loadScripts(
  [
    "https://g.alicdn.com/AWSC/AWSC/awsc.js",
    "https://g.alicdn.com/AWSC/fireyejs/1.223.1/fireyejs.js",
  ],
  function () {
    AWSC.use("nc", function (state, module) {
      // 初始化 1  用于滑块保持显示状态
      window.nc = module.init({
        // 应用类型标识。它和使用场景标识（scene字段）一起决定了滑动验证的业务场景与后端对应使用的策略模型。您可以在阿里云验证码控制台的配置管理页签找到对应的appkey字段值，请务必正确填写。
        appkey: "FFFF0N0000000000AF9A",
        //使用场景标识。它和应用类型标识（appkey字段）一起决定了滑动验证的业务场景与后端对应使用的策略模型。您可以在阿里云验证码控制台的配置管理页签找到对应的scene值，请务必正确填写。
        scene: "nc_login",
        // 声明滑动验证需要渲染的目标ID。
        renderTo: "slideVerify",
        // //滑动条的宽度，自行定义。
        hideErrorCode: true,
        upLang: myLang,
        //前端滑动验证通过时会触发该回调参数。您可以在该回调参数中将会话ID（sessionId）、签名串（sig）、请求唯一标识（token）字段记录下来，随业务请求一同发送至您的服务端调用验签。
        success: function (data) {
          Ecp_alysig = data.sig;
          Ecp_alysid = data.sessionId;
          Ecp_alytok = data.token;
          $("#nc_scene").val("nc_login");
          $("#nc_appkey").val("FFFF0N0000000000AF9A");
        },
        // 滑动验证失败时触发该回调参数。
        fail: function (failCode) {
          window.console && console.log(failCode);
          // window.nc.reset()
          writeErrorLog(2, failCode);
        },
        // 验证码加载出现异常时触发该回调参数。
        error: function (errorCode) {
          window.console && console.log(errorCode);
          writeErrorLog(3, errorCode);
        },
      });
    });
  }
);

function loadScripts(srcArray, callback) {
  var head = document.getElementsByTagName("head")[0];
  if (!head) {
    head = document.getElementsByTagName("body")[0];
  }
  var finished = 0;
  for (var i = 0; i < srcArray.length; i++) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.charset = "UTF-8";
    script.src = srcArray[i];
    if (script.addEventListener) {
      script.addEventListener(
        "load",
        function () {
          finished++;
          if (finished == srcArray.length) {
            if (
              typeof callback != "undefined" &&
              callback instanceof Function
            ) {
              callback();
            }
          }
        },
        false
      );
    } else if (script.attachEvent) {
      script.attachEvent("onreadystatechange", function () {
        var target = window.event.srcElement;
        if (target.readyState == "loaded" || target.readyState == "complete") {
          finished++;
          if (finished == srcArray.length) {
            if (
              typeof callback != "undefined" &&
              callback instanceof Function
            ) {
              callback();
            }
          }
        }
      });
    }
    head.appendChild(script);
  }
}

// 签名参数
function createSign(reqUrl, target) {
  target = target;
  var w = reqUrl.indexOf("?");
  var urlstring = reqUrl.substr(w + 1, reqUrl.length); //通过?得到一个数组,取?后面的参数
  var urlstringarray1 = urlstring.split("&"); //分割成数组
  var urlstringarray2 = {};
  for (var i = 0; i < urlstringarray1.length; i++) {
    var M = urlstringarray1[i].indexOf("=");
    var urlstringarrayi1 = urlstringarray1[i].substr(0, M);
    var urlstringarrayi2 = urlstringarray1[i].substr(
      M + 1,
      urlstringarray1[i].length
    );
    if (urlstringarrayi1 !== "") {
      urlstringarray2[urlstringarrayi1] = decodeURIComponent(urlstringarrayi2.replace(/%/g, '%25'));
    }
  }
  var sortedParamsi = Object.keys(urlstringarray2);
  var sortedParams = sortedParamsi.sort(function (a, b) {
    return a.toLowerCase() > b.toLowerCase() ? 1 : -1;
  });

  var paramArr = [];
  var j = 0;
  for (var i in sortedParams) {
    if (j++ >= sortedParams.length) break;
    // if (sortedParams[i] !== null && urlstringarray2[sortedParams[i]] !== null && sortedParams[i] !== "" && urlstringarray2[sortedParams[i]] !== "") {
    paramArr.push(sortedParams[i]);
    paramArr.push("=");
    paramArr.push(urlstringarray2[sortedParams[i]]);
    // }
  }
  var sortedParams2 = paramArr.join("");
  var timestamp = Date.parse(new Date());
  var nonce = Math.sin(timestamp).toString().substr(6);
  var signatureold =
    timestamp +
    nonce +
    "t8b52yrsoyx66f35tk0p4nubrmrcglv5" +
    sortedParams2 +
    getCookie("Ecp_ClientId");
  signatureold = signatureold.replace(/ /g, "");
  var signature = md5(signatureold);
  var appID = "LoginWap";
  // return [timestamp,nonce,signature,appID]
  // 生成图形验证码使用原生的xhr请求
  if (target) {
    target.setRequestHeader("timestamp", timestamp);
    target.setRequestHeader("nonce", nonce);
    target.setRequestHeader("signature", signature);
    target.setRequestHeader("appID", appID);
    target.setRequestHeader("ClientID", getCookie("Ecp_ClientId"));
  } else {
    $(document).ajaxSend(function (event, jqxhr, settings) {
      jqxhr.setRequestHeader("timestamp", timestamp);
      jqxhr.setRequestHeader("nonce", nonce);
      jqxhr.setRequestHeader("signature", signature);
      jqxhr.setRequestHeader("appID", appID);
      jqxhr.setRequestHeader("ClientID", getCookie("Ecp_ClientId"));
    });
  }
}

// md5
!(function (n) {
  "use strict";
  function d(n, t) {
    var r = (65535 & n) + (65535 & t);
    return (((n >> 16) + (t >> 16) + (r >> 16)) << 16) | (65535 & r);
  }
  function f(n, t, r, e, o, u) {
    return d(((u = d(d(t, n), d(e, u))) << o) | (u >>> (32 - o)), r);
  }
  function l(n, t, r, e, o, u, c) {
    return f((t & r) | (~t & e), n, t, o, u, c);
  }
  function g(n, t, r, e, o, u, c) {
    return f((t & e) | (r & ~e), n, t, o, u, c);
  }
  function v(n, t, r, e, o, u, c) {
    return f(t ^ r ^ e, n, t, o, u, c);
  }
  function m(n, t, r, e, o, u, c) {
    return f(r ^ (t | ~e), n, t, o, u, c);
  }
  function c(n, t) {
    var r, e, o, u;
    (n[t >> 5] |= 128 << t % 32), (n[14 + (((t + 64) >>> 9) << 4)] = t);
    for (
      var c = 1732584193, f = -271733879, i = -1732584194, a = 271733878, h = 0;
      h < n.length;
      h += 16
    )
      (c = l((r = c), (e = f), (o = i), (u = a), n[h], 7, -680876936)),
        (a = l(a, c, f, i, n[h + 1], 12, -389564586)),
        (i = l(i, a, c, f, n[h + 2], 17, 606105819)),
        (f = l(f, i, a, c, n[h + 3], 22, -1044525330)),
        (c = l(c, f, i, a, n[h + 4], 7, -176418897)),
        (a = l(a, c, f, i, n[h + 5], 12, 1200080426)),
        (i = l(i, a, c, f, n[h + 6], 17, -1473231341)),
        (f = l(f, i, a, c, n[h + 7], 22, -45705983)),
        (c = l(c, f, i, a, n[h + 8], 7, 1770035416)),
        (a = l(a, c, f, i, n[h + 9], 12, -1958414417)),
        (i = l(i, a, c, f, n[h + 10], 17, -42063)),
        (f = l(f, i, a, c, n[h + 11], 22, -1990404162)),
        (c = l(c, f, i, a, n[h + 12], 7, 1804603682)),
        (a = l(a, c, f, i, n[h + 13], 12, -40341101)),
        (i = l(i, a, c, f, n[h + 14], 17, -1502002290)),
        (c = g(
          c,
          (f = l(f, i, a, c, n[h + 15], 22, 1236535329)),
          i,
          a,
          n[h + 1],
          5,
          -165796510
        )),
        (a = g(a, c, f, i, n[h + 6], 9, -1069501632)),
        (i = g(i, a, c, f, n[h + 11], 14, 643717713)),
        (f = g(f, i, a, c, n[h], 20, -373897302)),
        (c = g(c, f, i, a, n[h + 5], 5, -701558691)),
        (a = g(a, c, f, i, n[h + 10], 9, 38016083)),
        (i = g(i, a, c, f, n[h + 15], 14, -660478335)),
        (f = g(f, i, a, c, n[h + 4], 20, -405537848)),
        (c = g(c, f, i, a, n[h + 9], 5, 568446438)),
        (a = g(a, c, f, i, n[h + 14], 9, -1019803690)),
        (i = g(i, a, c, f, n[h + 3], 14, -187363961)),
        (f = g(f, i, a, c, n[h + 8], 20, 1163531501)),
        (c = g(c, f, i, a, n[h + 13], 5, -1444681467)),
        (a = g(a, c, f, i, n[h + 2], 9, -51403784)),
        (i = g(i, a, c, f, n[h + 7], 14, 1735328473)),
        (c = v(
          c,
          (f = g(f, i, a, c, n[h + 12], 20, -1926607734)),
          i,
          a,
          n[h + 5],
          4,
          -378558
        )),
        (a = v(a, c, f, i, n[h + 8], 11, -2022574463)),
        (i = v(i, a, c, f, n[h + 11], 16, 1839030562)),
        (f = v(f, i, a, c, n[h + 14], 23, -35309556)),
        (c = v(c, f, i, a, n[h + 1], 4, -1530992060)),
        (a = v(a, c, f, i, n[h + 4], 11, 1272893353)),
        (i = v(i, a, c, f, n[h + 7], 16, -155497632)),
        (f = v(f, i, a, c, n[h + 10], 23, -1094730640)),
        (c = v(c, f, i, a, n[h + 13], 4, 681279174)),
        (a = v(a, c, f, i, n[h], 11, -358537222)),
        (i = v(i, a, c, f, n[h + 3], 16, -722521979)),
        (f = v(f, i, a, c, n[h + 6], 23, 76029189)),
        (c = v(c, f, i, a, n[h + 9], 4, -640364487)),
        (a = v(a, c, f, i, n[h + 12], 11, -421815835)),
        (i = v(i, a, c, f, n[h + 15], 16, 530742520)),
        (c = m(
          c,
          (f = v(f, i, a, c, n[h + 2], 23, -995338651)),
          i,
          a,
          n[h],
          6,
          -198630844
        )),
        (a = m(a, c, f, i, n[h + 7], 10, 1126891415)),
        (i = m(i, a, c, f, n[h + 14], 15, -1416354905)),
        (f = m(f, i, a, c, n[h + 5], 21, -57434055)),
        (c = m(c, f, i, a, n[h + 12], 6, 1700485571)),
        (a = m(a, c, f, i, n[h + 3], 10, -1894986606)),
        (i = m(i, a, c, f, n[h + 10], 15, -1051523)),
        (f = m(f, i, a, c, n[h + 1], 21, -2054922799)),
        (c = m(c, f, i, a, n[h + 8], 6, 1873313359)),
        (a = m(a, c, f, i, n[h + 15], 10, -30611744)),
        (i = m(i, a, c, f, n[h + 6], 15, -1560198380)),
        (f = m(f, i, a, c, n[h + 13], 21, 1309151649)),
        (c = m(c, f, i, a, n[h + 4], 6, -145523070)),
        (a = m(a, c, f, i, n[h + 11], 10, -1120210379)),
        (i = m(i, a, c, f, n[h + 2], 15, 718787259)),
        (f = m(f, i, a, c, n[h + 9], 21, -343485551)),
        (c = d(c, r)),
        (f = d(f, e)),
        (i = d(i, o)),
        (a = d(a, u));
    return [c, f, i, a];
  }
  function i(n) {
    for (var t = "", r = 32 * n.length, e = 0; e < r; e += 8)
      t += String.fromCharCode((n[e >> 5] >>> e % 32) & 255);
    return t;
  }
  function a(n) {
    var t = [];
    for (t[(n.length >> 2) - 1] = void 0, e = 0; e < t.length; e += 1) t[e] = 0;
    for (var r = 8 * n.length, e = 0; e < r; e += 8)
      t[e >> 5] |= (255 & n.charCodeAt(e / 8)) << e % 32;
    return t;
  }
  function e(n) {
    for (var t, r = "0123456789abcdef", e = "", o = 0; o < n.length; o += 1)
      (t = n.charCodeAt(o)), (e += r.charAt((t >>> 4) & 15) + r.charAt(15 & t));
    return e;
  }
  function r(n) {
    return unescape(encodeURIComponent(n));
  }
  function o(n) {
    return i(c(a((n = r(n))), 8 * n.length));
  }
  function u(n, t) {
    return (function (n, t) {
      var r,
        e = a(n),
        o = [],
        u = [];
      for (
        o[15] = u[15] = void 0,
          16 < e.length && (e = c(e, 8 * n.length)),
          r = 0;
        r < 16;
        r += 1
      )
        (o[r] = 909522486 ^ e[r]), (u[r] = 1549556828 ^ e[r]);
      return (
        (t = c(o.concat(a(t)), 512 + 8 * t.length)), i(c(u.concat(t), 640))
      );
    })(r(n), r(t));
  }
  function t(n, t, r) {
    return t ? (r ? u(t, n) : e(u(t, n))) : r ? o(n) : e(o(n));
  }
  "function" == typeof define && define.amd
    ? define(function () {
        return t;
      })
    : "object" == typeof module && module.exports
    ? (module.exports = t)
    : (n.md5 = t);
})(this);

function getCookie(cname) {
  var name = cname + "=";
  var ca = document.cookie.split(";");
  for (var i = 0; i < ca.length; i++) {
    var c = ca[i].trim();
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return null;
}
